diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/matrix-array.h ns-3.38/src/core/model/matrix-array.h
--- ns-3.37/src/core/model/matrix-array.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/model/matrix-array.h	2023-03-16 20:54:23.592868600 -0700
@@ -0,0 +1,311 @@
+/*
+ * Copyright (c) 2022 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Biljana Bojovic <bbojovic@cttc.es>
+ */
+
+#ifndef MATRIX_ARRAY_H
+#define MATRIX_ARRAY_H
+
+#include "val-array.h"
+
+#include <valarray>
+
+namespace ns3
+{
+
+/**
+ * \ingroup Matrices
+ *
+ * \brief MatrixArray class inherits ValArray class and provides additional
+ * interfaces to ValArray which enable page-wise linear algebra operations for
+ * arrays of matrices. While ValArray class is focused on efficient storage,
+ * access and basic algebra element-wise operations on 3D numerical arrays,
+ * MatrixArray is focused on the efficient algebra operations on arrays of
+ * matrices.
+ *
+ * Each page (2-dimensional array) within a 3D array is considered to
+ * be a matrix, and operations are performed separately for each page/matrix.
+ * For example, a multiplication of two MatrixArrays means that a matrix
+ * multiplication is performed between each page in the first MatrixArray with
+ * the corresponding page in the second MatrixArray. Some of the operations can
+ * use the Eigen3 matrix library for speedup. In addition, this class can be
+ * extended to provide interfaces to the Eigen3 matrix library and enable
+ * additional linear algebra operations. The objective of this class is to two-fold:
+ *
+ * - First, it provides simple interfaces to perform matrix operations in parallel
+ * on all pages without the need to write an outer loop over all the pages.
+ *
+ * - Second, it can improve the performance of such parallel matrix operations,
+ * as this class uses a single memory allocation and one common set of size
+ * variables (rows, cols) for all pages, which can be an advantage compared to
+ * having separate memory allocations and size variables for each page/matrix,
+ * especially when those matrices are very small.
+ *
+ * Important characteristics:
+ *
+ * - Matrices are in column-major order.
+ *
+ * - Matrices can be 1-dimensional, in the sense that either the number of rows
+ * or columns is equal to 1.
+ *
+ * - The array of matrices can contain just one matrix or more matrices.
+ *
+ * - For binary operators, both MatrixArrays must have an equal number of pages,
+ * as well compatible row and column dimensions between the matrices.
+ *
+ * - Binary operators are performed among matrices with the same index from lhs
+ * and rhs matrix.
+ *
+ * - MatrixArray improves computationally complex matrix operations by using
+ * Eigen library when it is available at compile time. MatrixArray class makes
+ * use of Eigen Map class, which allows re-using already existing portion of
+ * memory as an Eigen type, e.g. ValArray can return a pointer to a memory
+ * where are placed elements of a specific matrix, and this can be passed to
+ * Eigen Map class which does not do a copy of the elements, but is using these
+ * elements directly in linear algebra operations.
+ */
+template <class T>
+class MatrixArray : public ValArray<T>
+{
+  public:
+    // instruct the compiler to generate the default constructor
+    MatrixArray<T>() = default;
+    /**
+     * \brief Constructor "pages" number of matrices that are of size "numRows"x"numCols",
+     * and are initialized with all-zero elements.
+     * If only 1 parameter, numRows, is provided then a single 1D array is being created.
+     * \param numRows the number of rows
+     * \param numCols the number of columns
+     * \param numPages the number of pages
+     */
+    MatrixArray<T>(uint16_t numRows, uint16_t numCols = 1, uint16_t numPages = 1);
+    /**
+     * \brief Constructor creates a single array of values.size () elements and 1 column,
+     * and uses std::valarray<T> values to initialize the elements.
+     * \param values std::valarray<T> that will be used to initialize elements of 1D array
+     */
+    explicit MatrixArray<T>(const std::valarray<T>& values);
+    /**
+     * \brief Constructor creates a single array of values.size () elements and 1 column,
+     * and moves std::valarray<T> values to initialize the elements.
+     * \param values std::valarray<T> that will be moved to initialize elements of 1D array
+     */
+    MatrixArray<T>(std::valarray<T>&& values);
+    /**
+     * \brief Constructor creates a single array of values.size () elements and 1 column,
+     * and uses std::vector<T> values to initialize the elements.
+     * \param values std::vector<T> that will be used to initialize elements of 1D array
+     */
+    explicit MatrixArray<T>(const std::vector<T>& values);
+    /**
+     * \brief Constructor creates a single matrix of numRows and numCols, and uses
+     * std::valarray<T> values to initialize the elements.
+     * \param numRows the number of rows
+     * \param numCols the number of columns
+     * \param values std::valarray<T> that will be used to initialize elements of 3D array
+     */
+    MatrixArray<T>(uint16_t numRows, uint16_t numCols, const std::valarray<T>& values);
+    /**
+     * \brief Constructor creates a single matrix of numRows and numCols, and moves
+     * std::valarray<T> values to initialize the elements.
+     * \param numRows the number of rows
+     * \param numCols the number of columns
+     * \param values std::valarray<T> that will be moved to initialize elements of 3D array
+     */
+    MatrixArray<T>(uint16_t numRows, uint16_t numCols, std::valarray<T>&& values);
+    /**
+     * \brief Constructor creates the array of numPages matrices of numRows x numCols dimensions,
+     * and uses std::valarray<T> values to initialize all the elements.
+     * \param numRows the number of rows
+     * \param numCols the number of columns
+     * \param numPages the number of pages
+     * \param values std::valarray<T> that will be used to initialize elements of 3D array
+     */
+    MatrixArray<T>(uint16_t numRows,
+                   uint16_t numCols,
+                   uint16_t numPages,
+                   const std::valarray<T>& values);
+    /**
+     * \brief Constructor creates the array of numPages matrices of numRows x numCols dimensions,
+     * and moves std::valarray<T> values to initialize all the elements.
+     * \param numRows the number of rows
+     * \param numCols the number of columns
+     * \param numPages the number of pages
+     * \param values std::valarray<T> that will be used to initialize elements of 3D array
+     */
+    MatrixArray<T>(uint16_t numRows,
+                   uint16_t numCols,
+                   uint16_t numPages,
+                   std::valarray<T>&& values);
+    /** instruct the compiler to generate the implicitly declared destructor*/
+    ~MatrixArray<T>() override = default;
+    /** instruct the compiler to generate the implicitly declared copy constructor*/
+    MatrixArray<T>(const MatrixArray<T>&) = default;
+    /**
+     * \brief Copy assignment operator.
+     * Instruct the compiler to generate the implicitly declared copy assignment operator.
+     * \return a reference to the result of the assignment
+     */
+    MatrixArray<T>& operator=(const MatrixArray<T>&) = default;
+    /** instruct the compiler to generate the implicitly declared move constructor*/
+    MatrixArray<T>(MatrixArray<T>&&) = default;
+    /**
+     * \brief Move assignment operator.
+     * Instruct the compiler to generate the implicitly declared move assignment operator.
+     * \return a reference to the result of the assignment
+     */
+    MatrixArray<T>& operator=(MatrixArray<T>&&) = default;
+    /**
+     * \brief Element-wise multiplication with a scalar value.
+     * \param rhs is a scalar value of type T
+     * \returns The matrix in which each element has been multiplied by the given
+     * scalar value.
+     */
+    MatrixArray<T> operator*(const T& rhs) const;
+    /**
+     * \brief operator+ definition for MatrixArray<T>.
+     * \param rhs The rhs MatrixArray object
+     * \returns The result of operator+ of this MatrixArray and rhs MatrixAray
+     */
+    MatrixArray<T> operator+(const MatrixArray<T>& rhs) const;
+    /**
+     * \brief binary operator- definition for MatrixArray<T>.
+     * \param rhs The rhs MatrixArray object
+     * \returns The result of operator- of this MatrixArray and rhs MatrixAray
+     */
+    MatrixArray<T> operator-(const MatrixArray<T>& rhs) const;
+    /**
+     * \brief unary operator- definition for MatrixArray<T>.
+     * \return the result of the operator-
+     */
+    MatrixArray<T> operator-() const;
+    /**
+     * \brief Page-wise matrix multiplication.
+     * This operator interprets the 3D array as an array of matrices,
+     * and performs a linear algebra operation on each of the matrices (pages),
+     * i.e., matrices from this MatrixArray and rhs with the same page indices are
+     * multiplied.
+     * The number of columns of this MatrixArray must be equal to the number of
+     * rows in rhs, and rhs must have the same number of pages as this MatrixArray.
+     * \param rhs is another MatrixArray instance
+     * \returns The array of results of matrix multiplications.
+     */
+    MatrixArray<T> operator*(const MatrixArray<T>& rhs) const;
+    /**
+     * \brief This operator interprets the 3D array as an array of matrices,
+     * and performs a linear algebra operation on each of the matrices (pages),
+     * i.e., transposes the matrix or array of matrices definition for MatrixArray<T>.
+     * \return The resulting MatrixArray composed of the array of transposed matrices.
+     */
+    MatrixArray<T> Transpose() const;
+    /**
+     *\brief Multiply each matrix in the array by the left and the right matrix.
+     * For each page of this MatrixArray the operation performed is
+     * lMatrix * matrix(pageIndex) * rMatrix, and the resulting MatrixArray<T>
+     * contains the array of the results per page. If "this" has dimensions
+     * M x N x P, lMatrix must have dimensions M number of columns, and a single
+     * page, and rMatrix must have N number of rows, and also a single page.
+     *
+     * The result of this function will have the dimensions J x K x P. Where J is
+     * the number of rows of the lMatrix, and K is the number of
+     * columns of rMatrix. Dimensions are:
+     *
+     * lMatrix(JxMx1) * this (MxNxP) * rMatrix(NxKx1) -> result(JxKxP)
+     *
+     * This operation is not possible when using the multiplication operator because
+     * the number of pages does not match.
+     *
+     * \param lMatrix the left matrix in the multiplication
+     * \param rMatrix the right matrix in the multiplication
+     * \returns Returns the result of the multiplication which is a 3D MatrixArray
+     * with dimensions J x K x P as explained previously.
+     */
+    MatrixArray<T> MultiplyByLeftAndRightMatrix(const MatrixArray<T>& lMatrix,
+                                                const MatrixArray<T>& rMatrix) const;
+
+    using ValArray<T>::GetPagePtr;
+    using ValArray<T>::EqualDims;
+    using ValArray<T>::AssertEqualDims;
+
+    /**
+     * \brief Function that performs the Hermitian transpose of this MatrixArray
+     * and returns a new matrix that is the result of the operation.
+     * This function assumes that the matrix contains complex numbers, because of that
+     * it is only available for the <std::complex<double>> specialization of MatrixArray.
+     * \return Returns a new matrix that is the result of the Hermitian transpose
+     */
+    template <bool EnableBool = true,
+              typename = typename std::enable_if<(std::is_same<T, std::complex<double>>::value &&
+                                                  EnableBool)>::type>
+    MatrixArray<T> HermitianTranspose() const;
+
+  private:
+    // To simplify functions in MatrixArray that are using members from the template base class
+    using ValArray<T>::m_numRows;
+    using ValArray<T>::m_numCols;
+    using ValArray<T>::m_numPages;
+    using ValArray<T>::m_values;
+};
+
+/// Create an alias for MatrixArray using int type
+using IntMatrixArray = MatrixArray<int>;
+
+/// Create an alias for MatrixArray using double type
+using DoubleMatrixArray = MatrixArray<double>;
+
+/// Create an alias for MatrixArray using complex type
+using ComplexMatrixArray = MatrixArray<std::complex<double>>;
+
+/*************************************************
+ **  Class MatrixArray inline implementations
+ ************************************************/
+template <class T>
+inline MatrixArray<T>
+MatrixArray<T>::operator*(const T& rhs) const
+{
+    return MatrixArray<T>(m_numRows,
+                          m_numCols,
+                          m_numPages,
+                          m_values * std::valarray<T>(rhs, m_numRows * m_numCols * m_numPages));
+}
+
+template <class T>
+inline MatrixArray<T>
+MatrixArray<T>::operator+(const MatrixArray<T>& rhs) const
+{
+    AssertEqualDims(rhs);
+    return MatrixArray<T>(m_numRows, m_numCols, m_numPages, m_values + rhs.m_values);
+}
+
+template <class T>
+inline MatrixArray<T>
+MatrixArray<T>::operator-(const MatrixArray<T>& rhs) const
+{
+    AssertEqualDims(rhs);
+    return MatrixArray<T>(m_numRows, m_numCols, m_numPages, m_values - rhs.m_values);
+}
+
+template <class T>
+inline MatrixArray<T>
+MatrixArray<T>::operator-() const
+{
+    return MatrixArray<T>(m_numRows, m_numCols, m_numPages, -m_values);
+}
+
+} // namespace ns3
+
+#endif // MATRIX_ARRAY_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/nstime.h ns-3.38/src/core/model/nstime.h
--- ns-3.37/src/core/model/nstime.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/nstime.h	2023-03-16 20:54:23.592868600 -0700
@@ -465,11 +465,11 @@
      * user-provided time values in Time objects and Time objects
      * in user-expected time units.
      */
-    static void SetResolution(enum Unit resolution);
+    static void SetResolution(Unit resolution);
     /**
      * \returns The current global resolution.
      */
-    static enum Unit GetResolution();
+    static Unit GetResolution();
 
     /**
      * Create a Time in the current unit.
@@ -495,7 +495,7 @@
      * \param [in] unit The unit of \pname{value}
      * \return The Time representing \pname{value} in \c unit
      */
-    inline static Time FromInteger(uint64_t value, enum Unit unit)
+    inline static Time FromInteger(uint64_t value, Unit unit)
     {
         struct Information* info = PeekInformation(unit);
 
@@ -512,12 +512,12 @@
         return Time(value);
     }
 
-    inline static Time FromDouble(double value, enum Unit unit)
+    inline static Time FromDouble(double value, Unit unit)
     {
         return From(int64x64_t(value), unit);
     }
 
-    inline static Time From(const int64x64_t& value, enum Unit unit)
+    inline static Time From(const int64x64_t& value, Unit unit)
     {
         struct Information* info = PeekInformation(unit);
 
@@ -551,7 +551,7 @@
      * \param [in] unit The desired unit
      * \return The Time expressed in \pname{unit}
      */
-    inline int64_t ToInteger(enum Unit unit) const
+    inline int64_t ToInteger(Unit unit) const
     {
         struct Information* info = PeekInformation(unit);
 
@@ -569,12 +569,12 @@
         return v;
     }
 
-    inline double ToDouble(enum Unit unit) const
+    inline double ToDouble(Unit unit) const
     {
         return To(unit).GetDouble();
     }
 
-    inline int64x64_t To(enum Unit unit) const
+    inline int64x64_t To(Unit unit) const
     {
         struct Information* info = PeekInformation(unit);
 
@@ -600,7 +600,7 @@
      * \param [in] unit The unit to round to.
      * \return The Time rounded to the specific unit.
      */
-    Time RoundTo(enum Unit unit) const
+    Time RoundTo(Unit unit) const
     {
         return From(this->To(unit).Round(), unit);
     }
@@ -618,7 +618,7 @@
      * \param [in] unit The unit to use.
      * \return The Time with embedded unit.
      */
-    TimeWithUnit As(const enum Unit unit = Time::AUTO) const;
+    TimeWithUnit As(const Unit unit = Time::AUTO) const;
 
     /**
      * TracedCallback signature for Time
@@ -642,8 +642,8 @@
     /** Current time unit, and conversion info. */
     struct Resolution
     {
-        struct Information info[LAST]; //!<  Conversion info from current unit
-        enum Time::Unit unit;          //!<  Current time unit
+        Information info[LAST]; //!<  Conversion info from current unit
+        Time::Unit unit;        //!<  Current time unit
     };
 
     /**
@@ -663,7 +663,7 @@
      *  \param [in] timeUnit The Unit to get Information for
      *  \return The Information for \pname{timeUnit}
      */
-    static inline struct Information* PeekInformation(enum Unit timeUnit)
+    static inline struct Information* PeekInformation(Unit timeUnit)
     {
         return &(PeekResolution()->info[timeUnit]);
     }
@@ -681,9 +681,7 @@
      *  \param [in,out] resolution The Resolution record to update.
      *  \param [in] convert Whether to convert existing Time objects to the new resolution.
      */
-    static void SetResolution(enum Unit unit,
-                              struct Resolution* resolution,
-                              const bool convert = true);
+    static void SetResolution(Unit unit, Resolution* resolution, const bool convert = true);
 
     /**
      *  Record all instances of Time, so we can rescale them when
@@ -762,7 +760,7 @@
      *  Convert existing Times to the new unit.
      *  \param [in] unit The Unit to convert existing Times to.
      */
-    static void ConvertTimes(const enum Unit unit);
+    static void ConvertTimes(const Unit unit);
 
     // Operator and related functions which need access
 
@@ -1060,7 +1058,7 @@
  * Exact division, returning a dimensionless fixed point number.
  *
  * This can be truncated to integer, or converted to double
- * (with loss of precison).  Assuming `ta` and `tb` are Times:
+ * (with loss of precision).  Assuming `ta` and `tb` are Times:
  *
  * \code
  *     int64x64_t ratio = ta / tb;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/object-base.cc ns-3.38/src/core/model/object-base.cc
--- ns-3.37/src/core/model/object-base.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/object-base.cc	2023-03-16 20:54:23.592868600 -0700
@@ -18,17 +18,15 @@
  */
 #include "object-base.h"
 
+#include "assert.h"
 #include "attribute-construction-list.h"
+#include "environment-variable.h"
 #include "log.h"
 #include "string.h"
 #include "trace-source-accessor.h"
 
 #include "ns3/core-config.h"
 
-#include <cstdlib> // getenv
-#include <cstring> // strlen
-#include <unordered_map>
-
 /**
  * \file
  * \ingroup object
@@ -42,64 +40,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(ObjectBase);
 
-/** Unnamed namespace */
-namespace
-{
-
-/**
- * Get key, value pairs from the "NS_ATTRIBUTE_DEFAULT" environment variable.
- *
- * \param [in] key The key to search for.
- * \return \c true if the key was found, and the associated value.
- */
-std::pair<bool, std::string>
-EnvDictionary(std::string key)
-{
-    static std::unordered_map<std::string, std::string> dict;
-
-    if (dict.size() == 0)
-    {
-        const char* envVar = getenv("NS_ATTRIBUTE_DEFAULT");
-        if (envVar != nullptr && std::strlen(envVar) > 0)
-        {
-            std::string env = envVar;
-            std::string::size_type cur = 0;
-            std::string::size_type next = 0;
-            while (next != std::string::npos)
-            {
-                next = env.find(';', cur);
-                std::string tmp = std::string(env, cur, next - cur);
-                std::string::size_type equal = tmp.find('=');
-                if (equal != std::string::npos)
-                {
-                    std::string name = tmp.substr(0, equal);
-                    std::string envval = tmp.substr(equal + 1, tmp.size() - equal - 1);
-                    dict.insert({name, envval});
-                }
-                cur = next + 1;
-            }
-        }
-        else
-        {
-            // insert an empty key, so we don't do this again
-            dict.insert({"", ""});
-        }
-    }
-
-    std::string value;
-    bool found{false};
-
-    auto loc = dict.find(key);
-    if (loc != dict.end())
-    {
-        value = loc->second;
-        found = true;
-    }
-    return {found, value};
-}
-
-} // unnamed namespace
-
 /**
  * Ensure the TypeId for ObjectBase gets fully configured
  * to anchor the inheritance tree properly.
@@ -137,27 +77,6 @@
     NS_LOG_FUNCTION(this);
 }
 
-/**
- * \def LOG_WHERE_VALUE(where, value)
- * Log where and what value we find for the attribute
- * \param where The source of the value
- * \param value The value found, or "nothing"
- */
-#ifdef NS3_LOG_ENABLE
-#define LOG_WHERE_VALUE(where, value)                                                              \
-    do                                                                                             \
-    {                                                                                              \
-        std::string valStr{"nothing"};                                                             \
-        if (value)                                                                                 \
-        {                                                                                          \
-            valStr = "\"" + value->SerializeToString(info.checker) + "\"";                         \
-        }                                                                                          \
-        NS_LOG_DEBUG(where << " gave " << valStr);                                                 \
-    } while (false)
-#else
-#define LOG_WHERE_VALUE(where, value)
-#endif
-
 void
 ObjectBase::ConstructSelf(const AttributeConstructionList& attributes)
 {
@@ -172,11 +91,10 @@
         {
             struct TypeId::AttributeInformation info = tid.GetAttribute(i);
             NS_LOG_DEBUG("try to construct \"" << tid.GetName() << "::" << info.name << "\"");
-
+            // is this attribute stored in this AttributeConstructionList instance ?
             Ptr<const AttributeValue> value = attributes.Find(info.checker);
             std::string where = "argument";
 
-            LOG_WHERE_VALUE(where, value);
             // See if this attribute should not be set here in the
             // constructor.
             if (!(info.flags & TypeId::ATTR_CONSTRUCT))
@@ -203,25 +121,28 @@
 
             if (!value)
             {
-                auto [found, val] = EnvDictionary(tid.GetAttributeFullName(i));
+                NS_LOG_DEBUG("trying to set from environment variable NS_ATTRIBUTE_DEFAULT");
+                auto [found, val] =
+                    EnvironmentVariable::Get("NS_ATTRIBUTE_DEFAULT", tid.GetAttributeFullName(i));
                 if (found)
                 {
+                    NS_LOG_DEBUG("found in environment: " << val);
                     value = Create<StringValue>(val);
                     where = "env var";
-                    LOG_WHERE_VALUE(where, value);
                 }
             }
 
-            bool initial = false;
+            bool initial{false};
             if (!value)
             {
-                // Set from Tid initialValue, which is guaranteed to exist
+                // This is guaranteed to exist
+                NS_LOG_DEBUG("falling back to initial value from tid");
                 value = info.initialValue;
                 where = "initial value";
                 initial = true;
-                LOG_WHERE_VALUE(where, value);
             }
 
+            // We have a matching attribute value, if only from the initialValue
             if (DoSet(info.accessor, info.checker, *value) || initial)
             {
                 // Setting from initial value may fail, e.g. setting
@@ -230,6 +151,29 @@
                 NS_LOG_DEBUG("construct \"" << tid.GetName() << "::" << info.name << "\" from "
                                             << where);
             }
+            else
+            {
+                /*
+                  One would think this is an error...
+
+                  but there are cases where `attributes.Find(info.checker)`
+                  returns a non-null value which still fails the `DoSet()` call.
+                  For example, `value` is sometimes a real `PointerValue`
+                  containing 0 as the pointed-to address.  Since value
+                  is not null (it just contains null) the initial
+                  value is not used, the DoSet fails, and we end up
+                  here.
+
+                  If we were adventurous we might try to fix this deep
+                  below DoSet, but there be dragons.
+                */
+                /*
+                NS_ASSERT_MSG(false,
+                              "Failed to set attribute '" << info.name << "' from '"
+                                                          << value->SerializeToString(info.checker)
+                                                          << "'");
+                */
+            }
 
         } // for i attributes
         tid = tid.GetParent();
@@ -237,8 +181,6 @@
     NotifyConstructionCompleted();
 }
 
-#undef LOG_WHERE_VALUE
-
 bool
 ObjectBase::DoSet(Ptr<const AttributeAccessor> accessor,
                   Ptr<const AttributeChecker> checker,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/object-base.h ns-3.38/src/core/model/object-base.h
--- ns-3.37/src/core/model/object-base.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/object-base.h	2023-03-16 20:54:23.592868600 -0700
@@ -21,6 +21,7 @@
 
 #include "callback.h"
 #include "type-id.h"
+#include "warnings.h"
 
 #include <list>
 #include <string>
@@ -29,7 +30,7 @@
  * \file
  * \ingroup object
  * ns3::ObjectBase declaration and
- * NS_OBJECT_ENSURE_REGISTERED() madro definition.
+ * NS_OBJECT_ENSURE_REGISTERED() macro definition.
  */
 
 /**
@@ -47,9 +48,11 @@
     {                                                                                              \
         Object##type##RegistrationClass()                                                          \
         {                                                                                          \
+            NS_WARNING_PUSH_DEPRECATED;                                                            \
             ns3::TypeId tid = type::GetTypeId();                                                   \
             tid.SetSize(sizeof(type));                                                             \
             tid.GetParent();                                                                       \
+            NS_WARNING_POP;                                                                        \
         }                                                                                          \
     } Object##type##RegistrationVariable
 
@@ -235,7 +238,7 @@
      */
     void GetAttribute(std::string name, AttributeValue& value) const;
     /**
-     * Get the value of an attribute without raising erros.
+     * Get the value of an attribute without raising errors.
      *
      * If the attribute could not be read this will return \c false,
      * but not raise any errors.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/object-factory.cc ns-3.38/src/core/model/object-factory.cc
--- ns-3.37/src/core/model/object-factory.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/object-factory.cc	2023-03-16 20:54:23.592868600 -0700
@@ -66,7 +66,7 @@
 ObjectFactory::DoSet(const std::string& name, const AttributeValue& value)
 {
     NS_LOG_FUNCTION(this << name << &value);
-    if (name == "")
+    if (name.empty())
     {
         return;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/pointer.h ns-3.38/src/core/model/pointer.h
--- ns-3.37/src/core/model/pointer.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/pointer.h	2023-03-16 20:54:23.592868600 -0700
@@ -136,6 +136,7 @@
         }
         if (!value->GetObject())
         {
+            // a null pointer is a valid value
             return true;
         }
         T* ptr = dynamic_cast<T*>(PeekPointer(value->GetObject()));
